/* eslint-disable */
import { useRef, useEffect } from 'react';

var useMouseHold = function useMouseHold(onClickHandler, _ref) {
  var interval = _ref.interval,
      delay = _ref.delay,
      disabled = _ref.disabled;
  var delayedIntervalRef = useRef(null);
  var intervalRef = useRef(null);
  useEffect(function () {
    return function () {
      return stopHold();
    };
  }, [disabled]);

  var startHold = function startHold(event) {
    if (delayedIntervalRef.current) return;
    delayedIntervalRef.current = setTimeout(function () {
      if (intervalRef.current) return;
      intervalRef.current = setInterval(function () {
        onClickHandler(event);
      }, interval);
    }, delay);
  };

  var stopHold = function stopHold(event) {
    if (delayedIntervalRef.current) {
      clearTimeout(delayedIntervalRef.current);
      delayedIntervalRef.current = null;
    }

    if (intervalRef.current) {
      clearInterval(intervalRef.current);
      intervalRef.current = null;
    }
  };

  return {
    onClick: onClickHandler,
    onMouseDown: startHold,
    onMouseUp: stopHold,
    onMouseLeave: stopHold
  };
};

export default useMouseHold;